# -*- coding: utf-8 -*-
# type: ignore
from __future__ import annotations

import http

from django.test import Client
from django.urls import reverse
import pytest
from pytest_django import asserts


@pytest.mark.django_db
def test_ok(authenticated_client: Client,
            association_out,
            ):
    # When
    result = authenticated_client.get(
        reverse('ui.associations.post_save', args=(association_out.pk,)),
    )

    # Then
    assert result.status_code == http.HTTPStatus.OK

    asserts.assertTemplateUsed('ui/associations/view.html')
    assert result.context['association'].pk == association_out.pk
    assert hasattr(result.context['association'], 'target') is True
    assert result.context['association'].target.pk == association_out.target.pk


@pytest.mark.django_db
def test_archived(authenticated_client: Client,
                  archived_association_out,
                  ):
    # When
    result = authenticated_client.get(
        reverse('ui.associations.post_save', args=(archived_association_out.pk,)),
    )

    # Then
    assert result.status_code == http.HTTPStatus.NOT_FOUND


@pytest.mark.django_db
def test_deleted(authenticated_client: Client,
                 deleted_association_out,
                 ):
    # When
    result = authenticated_client.get(
        reverse('ui.associations.post_save', args=(deleted_association_out.pk,)),
    )

    # Then
    assert result.status_code == http.HTTPStatus.NOT_FOUND


@pytest.mark.django_db
def test_not_found(authenticated_client: Client,
                   null_uuid,
                   ):
    # When
    result = authenticated_client.get(
        reverse('ui.associations.post_save', args=(null_uuid,)),
    )

    # Then
    assert result.status_code == http.HTTPStatus.NOT_FOUND


@pytest.mark.django_db
def test_other_account_association(authenticated_client: Client,
                                   other_account_association_out,
                                   ):
    # When
    result = authenticated_client.get(
        reverse('ui.associations.post_save', args=(other_account_association_out.pk,)),
    )

    # Then
    assert result.status_code == http.HTTPStatus.FORBIDDEN


@pytest.mark.django_db
def test_inactive_account(inactive_account_client: Client,
                          association_out,
                          ):
    # When
    result = inactive_account_client.get(
        reverse('ui.associations.post_save', args=(association_out.pk,)),
    )

    # Then
    asserts.assertRedirects(
        result,
        reverse(
            'ui.accounts.login',
            query=[
                ('next', reverse('ui.associations.post_save', args=(association_out.pk,))),
            ],
        ),
        fetch_redirect_response=False,
    )


@pytest.mark.django_db
def test_anonymous(client: Client,
                   association_out,
                   ):
    # When
    result = client.get(
        reverse('ui.associations.post_save', args=(association_out.pk,)),
    )

    # Then
    asserts.assertRedirects(
        result,
        reverse(
            'ui.accounts.login',
            query=[
                ('next', reverse('ui.associations.post_save', args=(association_out.pk,))),
            ],
        ),
        fetch_redirect_response=False,
    )
